Bug 1409867 - Review Request: python-btchip - 'btchip-python' is a library used to interface with Ledger hardware devices (Cryptocurrency)
Summary: Review Request: python-btchip - 'btchip-python' is a library used to interfac...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Jonny Heggheim
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-01-03 16:38 UTC by Mike Goodwin
Modified: 2017-01-13 11:51 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-01-13 07:21:04 UTC
Type: ---
hegjon: fedora-review+


Attachments (Terms of Use)

Description Mike Goodwin 2017-01-03 16:38:27 UTC
Spec URL: https://github.com/xenithorb/btchip-python-spec/blob/master/python2-btchip.spec

SRPM URL: https://copr-be.cloud.fedoraproject.org/results/xenithorb/btchip-python/fedora-25-x86_64/00494382-python2-btchip/python2-btchip-0.1.18-1.fc25.src.rpm


Description: 

btchip-python is a python API for communicating primarily with the Ledger HW.1
hardware bitcoin wallet. This library is also adds compatibility to Electrum in
order to use the "Nano", "Nano S", and other Ledger-based hardware wallets.


Fedora Account System Username: xenithorb


Additional info: The primary purpose for my packaging this python library is for use with the recently-packaged Electrum bitcoin wallet. Electrum can take advantage of this library in order to use Ledger-based hardware wallets, and the current method to use this in Fedora is to `sudo pip install btchip-python` which affects (obv.) global python packages.

Comment 1 Jonny Heggheim 2017-01-03 19:37:43 UTC
You should split the package like described here: https://fedoraproject.org/wiki/Packaging:Python#Common_SRPM_vs_split_SRPMs

You should also use the template used in the Example common spec file section on the Packaging Guidelines for Python. The one you use is to support older EPEL versions.

Fedora Packaging Guidelines for Python:
> If a piece of software supports python3, it must be packaged for python3.
Lets see if it works with python3. If not then we do not build it.


>Source0: https://github.com/LedgerHQ/%{srcname}/archive/v%{version}.tar.gz
This is a personal preference, but I like to download the release from the Python Package Index / pythonhosted.org, since that is what upstream publish.

Comment 2 Igor Gnatenko 2017-01-03 21:00:42 UTC
(In reply to Jonny Heggheim from comment #1)
> You should split the package like described here:
> https://fedoraproject.org/wiki/Packaging:Python#Common_SRPM_vs_split_SRPMs
> 
> You should also use the template used in the Example common spec file
> section on the Packaging Guidelines for Python. The one you use is to
> support older EPEL versions.
> 
> Fedora Packaging Guidelines for Python:
> > If a piece of software supports python3, it must be packaged for python3.
> Lets see if it works with python3. If not then we do not build it.
> 
> 
> >Source0: https://github.com/LedgerHQ/%{srcname}/archive/v%{version}.tar.gz
> This is a personal preference, but I like to download the release from the
> Python Package Index / pythonhosted.org, since that is what upstream publish.
However, it's preprocessed source and usually doesn't contain license and/or tests. Real source (github) is always better.

Comment 3 Mike Goodwin 2017-01-03 21:34:47 UTC
(In reply to Jonny Heggheim from comment #1)
> You should split the package like described here:
> https://fedoraproject.org/wiki/Packaging:Python#Common_SRPM_vs_split_SRPMs
> 
> You should also use the template used in the Example common spec file
> section on the Packaging Guidelines for Python. The one you use is to
> support older EPEL versions.
> 

This library does not yet support python3, so is the preferred method then to use the common spec here: https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file and then just comment out all the python3 related items?

> Fedora Packaging Guidelines for Python:
> > If a piece of software supports python3, it must be packaged for python3.
> Lets see if it works with python3. If not then we do not build it.
> 

It doesn't 

> 
> >Source0: https://github.com/LedgerHQ/%{srcname}/archive/v%{version}.tar.gz
> This is a personal preference, but I like to download the release from the
> Python Package Index / pythonhosted.org, since that is what upstream publish.

I'd prefer to stay with github if it's all the same. I have it added here as well: https://release-monitoring.org/project/12767/

Comment 4 Jonny Heggheim 2017-01-03 21:53:23 UTC
(In reply to Mike Goodwin from comment #3)
> This library does not yet support python3, so is the preferred method then
> to use the common spec here:
> https://fedoraproject.org/wiki/Packaging:Python#Example_common_spec_file and
> then just comment out all the python3 related items?
Yes, the name of the package without the 2-suffix, while the the name of the sub-package should include a 2-suffix. 

python-trezor is simular, it does not work with python3 yet, see http://pkgs.fedoraproject.org/cgit/rpms/python-trezor.git/tree/python-trezor.spec for an example.


> > Lets see if it works with python3. If not then we do not build it.
> It doesn't 
No worries.


> I'd prefer to stay with github if it's all the same. I have it added here as
> well: https://release-monitoring.org/project/12767/
Just use github

Comment 5 Mike Goodwin 2017-01-03 22:44:09 UTC
Updated:

SPEC: https://github.com/xenithorb/btchip-python-spec/blob/master/python-btchip.spec

SRPM: https://kojipkgs.fedoraproject.org//work/tasks/9054/17159054/python-btchip-0.1.18-2.fc25.src.rpm

Passed all rpmlint with no errors/warnings, and built on koji

Comment 6 Jonny Heggheim 2017-01-04 18:09:05 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[!]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "*No copyright* Apache", "Unknown or
     generated", "*No copyright* Apache (v2.0)". 22 files have unknown
     license.
btchip-python-0.1.18/btchip/btchipKeyRecovery.py
btchip-python-0.1.18/btchip/msqr.py
btchip-python-0.1.18/btchip/ui/personalization00start.py
btchip-python-0.1.18/btchip/ui/personalization01seed.py
btchip-python-0.1.18/btchip/ui/personalization02security.py
btchip-python-0.1.18/btchip/ui/personalization03config.py
btchip-python-0.1.18/btchip/ui/personalization04finalize.py
btchip-python-0.1.18/btchip/ui/personalizationseedbackup01.py
btchip-python-0.1.18/btchip/ui/personalizationseedbackup02.py
btchip-python-0.1.18/btchip/ui/personalizationseedbackup03.py
btchip-python-0.1.18/btchip/ui/personalizationseedbackup04.py
btchip-python-0.1.18/tests/testMultisigArmory.py
btchip-python-0.1.18/tests/testMultisigArmoryNo2FA.py
btchip-python-0.1.18/ui/personalization-00-start.ui
btchip-python-0.1.18/ui/personalization-01-seed.ui
btchip-python-0.1.18/ui/personalization-02-security.ui
btchip-python-0.1.18/ui/personalization-03-config.ui
btchip-python-0.1.18/ui/personalization-04-finalize.ui
btchip-python-0.1.18/ui/personalization-seedbackup-01.ui
btchip-python-0.1.18/ui/personalization-seedbackup-02.ui
btchip-python-0.1.18/ui/personalization-seedbackup-03.ui
btchip-python-0.1.18/ui/personalization-seedbackup-04.ui

Please contact upstream to clarify licensing. Best if they put proper license header and release new version.


[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: No rpmlint messages.
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[-]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
Your comment in the .spec file explains why it is disabled.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[!]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff).
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Checking: python2-btchip-0.1.18-2.fc26.noarch.rpm
          python-btchip-0.1.18-2.fc26.src.rpm
2 packages and 0 specfiles checked; 0 errors, 0 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
1 packages and 0 specfiles checked; 0 errors, 0 warnings.



Diff spec file in url and in SRPM
---------------------------------
--- /home/jonny/tmp/python-btchip.spec	2017-01-04 18:30:12.519562464 +0100
+++ /home/jonny/tmp/review-python-btchip/srpm-unpacked/python-btchip.spec	2017-01-03 23:35:11.000000000 +0100
@@ -3,5 +3,5 @@
 %global sum Python communication library for Ledger Hardware Wallet products
 %global desc %{srcname} is a python API for communicating primarily with the \
-Ledger HW.1 hardware bitcoin wallet. This library also adds compatibility \
+Ledger HW.1 hardware bitcoin wallet. This library is also adds compatibility \
 to Electrum in order to use the "Nano", "Nano S", and other Ledger-based \
 hardware wallets.
@@ -17,5 +17,5 @@
 
 BuildArch:     noarch
-# Tests require these but don't work without internet
+# Tests require these but dont' work without internet
 #BuildRequires: libusbx-devel systemd-devel
 


Requires
--------
python2-btchip (rpmlib, GLIBC filtered):
    hidapi
    python(abi)
    python2-hidapi



Provides
--------
python2-btchip:
    python-btchip
    python2-btchip



Source checksums
----------------
https://github.com/LedgerHQ/btchip-python/archive/v0.1.18.tar.gz :
  CHECKSUM(SHA256) this package     : a09008e008f4fdf5d9e9e1a533c06742e6f50bf60b8ab03195600ddf6381fd9b
  CHECKSUM(SHA256) upstream package : a09008e008f4fdf5d9e9e1a533c06742e6f50bf60b8ab03195600ddf6381fd9b


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -m fedora-rawhide-x86_64 -n python-btchip
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 7 Jonny Heggheim 2017-01-04 18:31:21 UTC
Must:
* Please contact upstream to clarify licensing. Best if they put proper license header and release new version.

Non critical:
* Consider removing the python3 code that is commented out.

Comment 8 Mike Goodwin 2017-01-04 19:09:44 UTC
Thanks Jonny! I've linked them to this review and have asked them to comment to me or the ticket in reply to the questionably-licensed files. 

Re: the python3 stuff in the spec, i was unsure about if you wanted that there because of what you said about following the new guidelines and potential python3 support in the future for one of your packaged libs. I spoke to btchip and he said they intend on supporting python3 with this library at some point. 

Still remove?

Comment 9 Jonny Heggheim 2017-01-04 19:22:18 UTC
(In reply to Mike Goodwin from comment #8)
> Thanks Jonny! I've linked them to this review and have asked them to comment
> to me or the ticket in reply to the questionably-licensed files. 
Great!

> Re: the python3 stuff in the spec, i was unsure about if you wanted that
> there because of what you said about following the new guidelines and
> potential python3 support in the future for one of your packaged libs. I
> spoke to btchip and he said they intend on supporting python3 with this
> library at some point. 
> 
> Still remove?
You decide, I would remove them now and add it later when btchip supports python3.

Comment 10 Jonny Heggheim 2017-01-04 19:22:43 UTC
Approved!

Comment 11 Gwyn Ciesla 2017-01-04 22:42:18 UTC
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/rpms/python-btchip

Comment 12 Fedora Update System 2017-01-05 01:11:26 UTC
python-btchip-0.1.18-3.fc25 has been submitted as an update to Fedora 25. https://bodhi.fedoraproject.org/updates/FEDORA-2017-b6b43c34c6

Comment 13 Fedora Update System 2017-01-05 01:12:04 UTC
python-btchip-0.1.18-3.fc24 has been submitted as an update to Fedora 24. https://bodhi.fedoraproject.org/updates/FEDORA-2017-6fd7ecc578

Comment 14 Fedora Update System 2017-01-05 23:20:45 UTC
python-btchip-0.1.18-3.fc24 has been pushed to the Fedora 24 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-6fd7ecc578

Comment 15 Fedora Update System 2017-01-05 23:50:45 UTC
python-btchip-0.1.18-3.fc25 has been pushed to the Fedora 25 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b6b43c34c6

Comment 16 Fedora Update System 2017-01-13 07:21:04 UTC
python-btchip-0.1.18-3.fc24 has been pushed to the Fedora 24 stable repository. If problems still persist, please make note of it in this bug report.

Comment 17 Fedora Update System 2017-01-13 11:51:10 UTC
python-btchip-0.1.18-3.fc25 has been pushed to the Fedora 25 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.